<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">

    <!-- bootstrap & jquery -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <script src="plugins/sweetalert2/sweetalert2.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Real Estate Add</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item dropdown mr-3">
                    <a class="nav-link" data-toggle="dropdown" href="#"><i class="fa-solid fa-user-large"></i></a>
                    <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
                        <span class="dropdown-item dropdown-header" id="user-info"></span>
                        <div class="dropdown-divider"></div>
                        <div class="text-center mt-2">
                            <button class="btn btn-danger" id="btn-log-out"><i
                                    class="fa-solid fa-right-from-bracket"></i> Log out</button>
                        </div>
                    </div>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->


        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="realestate1.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">ADMIN Real Estates</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="info text-white ml-2" id="username-info"></div>
                </div>
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class with font-awesome or any other icon font library -->
                        <li class="nav-item">
                            <a href="./realestate1.html" class="nav-link">
                                <i class="fa-solid fa-city"></i>
                                <p>
                                    Thông tin BĐS
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./advise.html" class="nav-link">
                                <i class="fa-solid fa-comment-medical"></i>
                                <p>
                                    Thông tin KH cần tư vấn
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Real Estate Add</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->
            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <h2 class="text-center mb-5">Cập nhật thông tin BĐS</h2>
                    <h5 class="text-center mb-5">Thông tin chi tiết</h5>
                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Tiêu đề tin</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-title" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Tỉnh thành<i class="text-danger">*</i></label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-province" class="form-control">
                                        <option value="0" hidden>--Tên tỉnh thành--</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Quận Huyện<i class="text-danger">*</i></label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-district" class="form-control" disabled>
                                        <option value="0" hidden>--Tên quận huyện--</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Dự án xây dựng</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-project" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Loại tin</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-type" class="form-control">
                                        <option value="0">Đất</option>
                                        <option value="1">Nhà ở</option>
                                        <option value="2">Căn hộ/ Chung cư</option>
                                        <option value="3">Văn phòng, mặt bằng</option>
                                        <option value="4">Kinh doanh</option>
                                        <option value="5">Phòng trọ</option>
                                    </select>
                                </div>
                            </div>

                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Giá đăng</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-price" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Giá tối thiểu</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-priceMin" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Thời gian bán</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-priceTime" type="number" class="form-control">
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-6 form-group">
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Địa chỉ <i class="text-danger">*</i></label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-address" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Phường Xã</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-ward" class="form-control" disabled>
                                        <option value="0" hidden>--Tên Phường Xã--</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Đường phố</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-street" class="form-control" disabled>
                                        <option value="0" hidden>--Tên Đường phố--</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Khách hàng</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-customer" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Nhân viên <i class="text-danger">*</i></label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-employee" class="form-control">
                                        <option value="0" hidden>--Employee--</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Nhu cầu</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-request" class="form-control">
                                        <option value="0">Cần bán</option>
                                        <option value="2">Cần mua</option>
                                        <option value="3">Cho thuê</option>
                                        <option value="4">Cần thuê</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Giá cho thuê</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-priceRent" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Trạng thái</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <select id="update-select-status" class="form-control">
                                        <option value="N">Chưa duyệt</option>
                                        <option value="Y">Đã duyệt</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h5 class="text-center mb-5">Thông số kỹ thuật 1</h5>
                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Diện tích BĐS</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-acreage" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Hướng nhà</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-direction" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Tổng số tầng</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-totalFloors" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Tầng số</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-numberFloors" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Diện tích tim tường</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-wallArea" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Vị trí căn hộ</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-apartLoca" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Loại nội thất</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-furnitureType" type="number" class="form-control">
                                </div>
                            </div>

                        </div>
                        <div class="col-sm-6 form-group">
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Mã căn hộ</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-apartCode" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Số nhà vệ sinh</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-bath" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Số phòng ngủ</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-bedroom" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Ban công</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-balcony" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Hướng cảnh quan</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-landscapeView" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Loại căn hộ</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-apartType" type="number" class="form-control">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h5 class="text-center mb-5">Thông số kỹ thuật 2</h5>
                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Tỉ suất sinh lời</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-returnRate" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Giấy tờ pháp lý</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-legalDoc" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Chiều rộng</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-widthY" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Chiều dài</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-longX" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>FSBO</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-fsbo" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Cập nhật bởi</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-updateBy" type="number" class="form-control">
                                </div>
                            </div>

                        </div>
                        <div class="col-sm-6 form-group">
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Mô tả chi tiết</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-description" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Street House</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-streetHouse" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Số lượt xem</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-viewNum" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Hình dáng nhà</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-shape" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Khoảng cách ra mặt tiền</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-distance2facade" type="number" class="form-control">
                                </div>
                            </div>


                        </div>
                    </div>

                    <h5 class="text-center mb-5">Thông số kỹ thuật 3</h5>
                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Số mặt tiền tiếp giáp</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-adjacent_facade_num" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Độ rộng hẻm nhỏ nhất</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-alley_min_width" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Độ rộng hẻm tiếp giáp</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-adjacent_alley_min_width" type="number"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>DTSXD</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-dtsxd" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>CLCL</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-clcl" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>CTXD_price</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-ctxd_price" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>CTXD_value</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-ctxd_value" type="number" class="form-control">
                                </div>
                            </div>

                        </div>
                        <div class="col-sm-6 form-group">
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Đường tiếp giáp bê tông</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-adjacentRoad" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Yếu tố khác</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-factor" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Kết cấu</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-structure" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Kinh độ</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-lng" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Vĩ độ</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-lat" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-md-4 text-left">
                                    <label>Ảnh</label>
                                </div>
                                <div class="col-md-8 form-group">
                                    <input id="update-input-photo" type="text" class="form-control">
                                </div>
                            </div>


                        </div>
                    </div>
                    <div class="form-group text-center">
                        <button class="btn btn-primary" id="btn-update-confirm">Confirm</button>
                        <button class="btn btn-secondary" id="btn-update-cancel">Cancel</button>
                    </div>
                </div><!-- /.container-fluid -->
            </section>
            <!-- /.content -->


        </div>
    </div>

    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>

    <script>
        $(document).ready(function () {

            const token = getCookie("token");
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

            var gId;

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();

            //Set sự kiện cho nút logout
            $("#btn-log-out").on("click", function () {
                redirectToLogin();
            });

            $("#btn-update-cancel").on("click", function () {
                window.location.href = "realestate.html"
            });

            $("#btn-update-confirm").on("click", function () {
                onBtnUpdateConfirmClick();
            })

            // gán xự kiện khi ô select thay đổi
            $("#update-select-province").on("change", function () {
                $("#update-select-district").html("");
                var bProvinceId = $(this).val();
                callApiGetDistrictByProvinceId(bProvinceId);
            });

            // gán xự kiện khi ô select thay đổi
            $("#update-select-district").on("change", function () {
                $("#update-select-ward").html("");
                $("#update-select-street").html("");
                var bDistrictId = $(this).val();
                callApiGetWardByDistrictId(bDistrictId);
                callApiGetStreetByDistrictId(bDistrictId);
            });


            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                "use strict";
                callApiGetUserIdByToken();
                callApiGetAllCustomer();
                callApiGetAllProject();
                callApiGetAllProvince();
                callApiGetAllEmployees();
                //tạo đối tượng url để truy vấn tham số 
                var vUrlObject = new URL(window.location.href);
                // đưa tham số customerId sang bằng query string
                var vRealEstateId = vUrlObject.searchParams.get("realEstateId");
                gId = vRealEstateId;
                if (vRealEstateId != null) {
                    callApiGetRealEstateDataById(vRealEstateId);
                } else {
                    alert("Không có dữ liệu RealEstateId.");
                    window.location.href = "realestate.html";
                }
            }

            // Hàm xử lý khi nút xác nhận tạo mới Real estate được nhấn
            function onBtnUpdateConfirmClick() {
                "use strict";
                var vUpdateData = {
                    title: "",
                    type: "",
                    request: "",
                    address: "",
                    price: "",
                    priceMin: "",
                    priceTime: "",
                    acreage: "",
                    direction: "",
                    totalFloors: "",
                    numberFloors: "",
                    bath: "",
                    apartCode: "",
                    wallArea: "",
                    bedroom: "",
                    balcony: "",
                    landscapeView: "",
                    apartLoca: "",
                    apartType: "",
                    furnitureType: "",
                    priceRent: "",
                    returnRate: "",
                    legalDoc: "",
                    description: "",
                    widthY: "",
                    longX: "",
                    streetHouse: "",
                    fsbo: "",
                    viewNum: "",
                    createBy: "",
                    updateBy: "",
                    shape: "",
                    distance2facade: "",
                    adjacent_facade_num: "",
                    adjacentRoad: "",
                    alley_min_width: "",
                    adjacent_alley_min_width: "",
                    factor: "",
                    structure: "",
                    dtsxd: "",
                    clcl: "",
                    ctxd_price: "",
                    ctxd_value: "",
                    photo: "",
                    lat: "",
                    lng: "",
                    status: "",
                }
                // B1: Thu thập dữ liệu
                var vProvinceValue = $("#update-select-province").val();
                var vDistrictValue = $("#update-select-district").val();
                var vWardValue = $("#update-select-ward").val();
                var vStreetValue = $("#update-select-street").val();
                var vCustomerValue = $("#update-select-customer").val();
                var vProjectValue = $("#update-select-project").val();
                var vEmployeeValue = $("#update-select-employee").val();
                getUpdateData(vUpdateData);
                // B2: Kiểm tra dữ liệu
                var isValidate = validateUpdateData(vUpdateData, vEmployeeValue);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiUpdateRealEstate(vUpdateData, vProvinceValue, vDistrictValue, vWardValue, vStreetValue, vCustomerValue, vProjectValue, vEmployeeValue);

                    window.location.href = "realestate1.html";
                }
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */

            function callApiGetUserIdByToken() {
                $.ajax({
                    url: "http://localhost:8080/findUserId/Token",
                    type: 'GET',
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    headers: {
                        "Authorization": "Token " + token,
                    },
                    success: function (responseObject) {
                        //console.log(responseObject);
                        callApiGetEmployeeByID(responseObject);
                    },
                    error: function (pAjaxContext) {
                        //redirectToLogin();
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu employee bằng id
            function callApiGetEmployeeByID(paramEmployeeId) {
                $.ajax({
                    url: "http://localhost:8080/employees/" + paramEmployeeId,
                    method: "GET",
                    async: false,
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        handlerUserDataResponse(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function handlerUserDataResponse(paramUserData) {
                $("#username-info").html(paramUserData.username);
                $("#user-info").html(paramUserData.username);
            }

            // Hàm gọi api lấy dữ liệu project bằng id
            function callApiGetRealEstateDataById(paramRealEstateId) {
                $.ajax({
                    url: "http://localhost:8080/realEstates/" + paramRealEstateId,
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataOnForm(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }


            // 
            function callApiUpdateRealEstate(paramUpdateData, paramProvince, paramDistrict, paramWard, paramStreet, paramCustomer, paramProject, paramEmployee) {
                $.ajax({
                    url: "http://localhost:8080/realEstates/" + gId + "/" + paramProvince + "/" + paramDistrict + "/" + paramWard + "/" + paramStreet + "/" + paramProject + "/" + paramCustomer + "/" + paramEmployee,
                    method: "PUT",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramUpdateData),
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alert("update Real Estate thành công. Real Estate có ID: " + paramResponseObj.id);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Update Real Estate không thành công.");
                    }
                });
            }


            // Hàm gọi api lấy tất cả customer
            function callApiGetAllCustomer() {
                $.ajax({
                    url: "http://localhost:8080/customers",
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToCustomerSelect(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api lấy tất cả project
            function callApiGetAllProject() {
                $.ajax({
                    url: "http://localhost:8080/projects",
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToProjectSelect(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api lấy tất cả employee
            function callApiGetAllEmployees() {
                $.ajax({
                    url: "http://localhost:8080/employees",
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToEmployeeSelect(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api tất cả tỉnh thành
            function callApiGetAllProvince() {
                $.ajax({
                    url: "http://localhost:8080/provinces",
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToProvinceSelect(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm xử lý gọi api lấy dữ liệu district bằng province id
            function callApiGetDistrictByProvinceId(paramProvinceId) {
                "use strict";
                $.ajax({
                    url: "http://localhost:8080/districts/province/" + paramProvinceId,
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToDistrictSelect(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm xử lý gọi api lấy dữ liệu ward bằng district id
            function callApiGetWardByDistrictId(paramDistrictId) {
                "use strict";
                $.ajax({
                    url: "http://localhost:8080/wards/district/" + paramDistrictId,
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToWardSelect(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm xử lý gọi api lấy dữ liệu street bằng distirct id
            function callApiGetStreetByDistrictId(paramDistrictId) {
                "use strict";
                $.ajax({
                    url: "http://localhost:8080/streets/district/" + paramDistrictId,
                    method: "GET",
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToStreetSelect(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Load dữ liệu vào ô select customer
            function loadDataToCustomerSelect(paramResponse) {
                "use strict";
                var vCustomerSelect = $("#update-select-customer");
                for (let i = 0; i < paramResponse.length; i++) {
                    var bCustomerOption = $("<option/>");
                    bCustomerOption.prop("value", paramResponse[i].id);
                    bCustomerOption.prop("text", paramResponse[i].contactName);
                    vCustomerSelect.append(bCustomerOption);
                };
            }

            // Load dữ liệu vào ô select project
            function loadDataToProjectSelect(paramResponse) {
                "use strict";
                var vProjectSelect = $("#update-select-project");
                for (let i = 0; i < paramResponse.length; i++) {
                    var bProjectOption = $("<option/>");
                    bProjectOption.prop("value", paramResponse[i].id);
                    bProjectOption.prop("text", paramResponse[i].name);
                    vProjectSelect.append(bProjectOption);
                };
            }

            // Load dữ liệu vào ô select employee
            function loadDataToEmployeeSelect(paramResponse) {
                "use strict";
                var vCreateEmployeeSelect = $("#update-select-employee");
                for (let i = 0; i < paramResponse.length; i++) {
                    var bOption = $("<option/>");
                    bOption.prop("value", paramResponse[i].employeeID);
                    bOption.prop("text", paramResponse[i].firstName + " " + paramResponse[i].lastName);
                    vCreateEmployeeSelect.append(bOption);
                };
            }

            // Load dữ liệu vào ô select province
            function loadDataToProvinceSelect(paramResponse) {
                "use strict";
                var vModalProvinceSelect = $("#update-select-province");
                for (let i = 0; i < paramResponse.length; i++) {
                    var bProvinceOption = $("<option/>");
                    bProvinceOption.prop("value", paramResponse[i].id);
                    bProvinceOption.prop("text", paramResponse[i].name);
                    vModalProvinceSelect.append(bProvinceOption);
                };
            }

            // Load dữ liệu phản hồi vào ô select district
            function loadDataToDistrictSelect(paramResDistrictList) {
                "use strict";
                var vDistrictSelectElement = $("#update-select-district");
                if (paramResDistrictList.length > 0) {
                    vDistrictSelectElement.prop("disabled", false);

                    for (let i = 0; i < paramResDistrictList.length; i++) {
                        var bDistrictOption = $("<option/>");
                        bDistrictOption.prop("value", paramResDistrictList[i].id);
                        bDistrictOption.prop("text", paramResDistrictList[i].name);
                        vDistrictSelectElement.append(bDistrictOption);
                    };
                } else {
                    vDistrictSelectElement.prop("disabled", true);
                }
            }

            // Load dữ liệu phản hồi vào ô select ward
            function loadDataToWardSelect(paramData) {
                "use strict";
                var vWardSelectElement = $("#update-select-ward");
                if (paramData.length > 0) {
                    vWardSelectElement.prop("disabled", false);

                    for (let i = 0; i < paramData.length; i++) {
                        var bWardOption = $("<option/>");
                        bWardOption.prop("value", paramData[i].id);
                        bWardOption.prop("text", paramData[i].name);
                        vWardSelectElement.append(bWardOption);
                    };
                } else {
                    vWardSelectElement.prop("disabled", true);
                }
            }

            // Load dữ liệu phản hồi vào ô select street
            function loadDataToStreetSelect(paramData) {
                "use strict";
                var vStreetSelectElement = $("#update-select-street");
                if (paramData.length > 0) {
                    vStreetSelectElement.prop("disabled", false);

                    for (let i = 0; i < paramData.length; i++) {
                        var bOption = $("<option/>");
                        bOption.prop("value", paramData[i].id);
                        bOption.prop("text", paramData[i].name);
                        vStreetSelectElement.append(bOption);
                    };
                } else {
                    vStreetSelectElement.prop("disabled", true);
                }
            }

            function getUpdateData(paramUpdateData) {
                paramUpdateData.title = $("#update-input-title").val().trim();
                paramUpdateData.type = $("#update-select-type").val();
                paramUpdateData.request = $("#update-select-request").val().trim();
                paramUpdateData.address = $("#update-input-address").val().trim();
                paramUpdateData.price = $("#update-input-price").val().trim();
                paramUpdateData.priceMin = $("#update-input-priceMin").val().trim();
                paramUpdateData.priceTime = $("#update-input-priceTime").val().trim();
                paramUpdateData.acreage = $("#update-input-acreage").val().trim();
                paramUpdateData.direction = $("#update-input-direction").val().trim();
                paramUpdateData.totalFloors = $("#update-input-totalFloors").val().trim();

                paramUpdateData.numberFloors = $("#update-input-numberFloors").val().trim();
                paramUpdateData.apartCode = $("#update-input-apartCode").val().trim();
                paramUpdateData.wallArea = $("#update-input-wallArea").val().trim();
                paramUpdateData.bedroom = $("#update-input-bedroom").val().trim();
                paramUpdateData.bath = $("#update-input-bath").val().trim();
                paramUpdateData.balcony = $("#update-input-balcony").val().trim();
                paramUpdateData.landscapeView = $("#update-input-landscapeView").val().trim();
                paramUpdateData.apartLoca = $("#update-input-apartLoca").val().trim();
                paramUpdateData.apartType = $("#update-input-apartType").val().trim();
                paramUpdateData.furnitureType = $("#update-input-furnitureType").val().trim();
                paramUpdateData.priceRent = $("#update-input-priceRent").val().trim();

                paramUpdateData.returnRate = $("#update-input-returnRate").val().trim();
                paramUpdateData.legalDoc = $("#update-input-legalDoc").val().trim();
                paramUpdateData.description = $("#update-input-description").val().trim();
                paramUpdateData.widthY = $("#update-input-widthY").val().trim();
                paramUpdateData.longX = $("#update-input-longX").val().trim();
                paramUpdateData.streetHouse = $("#update-input-streetHouse").val().trim();
                paramUpdateData.fsbo = $("#update-input-fsbo").val().trim();
                paramUpdateData.viewNum = $("#update-input-viewNum").val().trim();
                paramUpdateData.updateBy = $("#update-input-updateBy").val().trim();

                paramUpdateData.shape = $("#update-input-shape").val().trim();
                paramUpdateData.distance2facade = $("#update-input-distance2facade").val().trim();
                paramUpdateData.adjacent_facade_num = $("#update-input-adjacent_facade_num").val().trim();
                paramUpdateData.adjacentRoad = $("#update-input-adjacentRoad").val().trim();
                paramUpdateData.alley_min_width = $("#update-input-alley_min_width").val().trim();
                paramUpdateData.adjacent_alley_min_width = $("#update-input-adjacent_alley_min_width").val().trim();
                paramUpdateData.factor = $("#update-input-factor").val().trim();
                paramUpdateData.structure = $("#update-input-structure").val().trim();
                paramUpdateData.dtsxd = $("#update-input-dtsxd").val().trim();
                paramUpdateData.clcl = $("#update-input-clcl").val().trim();
                paramUpdateData.ctxd_price = $("#update-input-ctxd_price").val().trim();

                paramUpdateData.ctxd_value = $("#update-input-ctxd_value").val().trim();
                paramUpdateData.photo = $("#update-input-photo").val().trim();
                paramUpdateData.lat = $("#update-input-lat").val().trim();
                paramUpdateData.lng = $("#update-input-lng").val().trim();
                paramUpdateData.status = $("#update-select-status").val();
            }

            function validateUpdateData(paramUpdateData, paramEmployee) {
                "use strict";
                if (paramUpdateData.address == "") {
                    alertError("Address không được để trống");
                    return false;
                }
                if (paramEmployee == 0) {
                    alertError("Nhân viên phải được chọn.");
                    return false;
                }
                return true;
            }

            function loadDataOnForm(paramRealEstate) {
                $("#update-select-project").val(paramRealEstate.project.id);
                $("#update-select-employee").val(paramRealEstate.employee.employeeID);

                $("#update-input-title").val(paramRealEstate.title);
                $("#update-select-type").val(paramRealEstate.type);
                $("#update-select-request").val(paramRealEstate.request);
                $("#update-input-address").val(paramRealEstate.address);
                $("#update-input-price").val(paramRealEstate.price);
                $("#update-input-priceMin").val(paramRealEstate.priceMin);
                $("#update-input-priceTime").val(paramRealEstate.priceTime);
                $("#update-input-acreage").val(paramRealEstate.acreage);
                $("#update-input-direction").val(paramRealEstate.direction);
                $("#update-input-totalFloors").val(paramRealEstate.totalFloors);

                $("#update-input-numberFloors").val(paramRealEstate.numberFloors);
                $("#update-input-apartCode").val(paramRealEstate.apartCode);
                $("#update-input-wallArea").val(paramRealEstate.wallArea);
                $("#update-input-bedroom").val(paramRealEstate.bedroom);
                $("#update-input-bath").val(paramRealEstate.bath);
                $("#update-input-balcony").val(paramRealEstate.balcony);
                $("#update-input-landscapeView").val(paramRealEstate.landscapeView);
                $("#update-input-apartLoca").val(paramRealEstate.apartLoca);
                $("#update-input-apartType").val(paramRealEstate.apartType);
                $("#update-input-furnitureType").val(paramRealEstate.furnitureType);
                $("#update-input-priceRent").val(paramRealEstate.priceRent);

                $("#update-input-returnRate").val(paramRealEstate.returnRate);
                $("#update-input-legalDoc").val(paramRealEstate.legalDoc);
                $("#update-input-description").val(paramRealEstate.description);
                $("#update-input-widthY").val(paramRealEstate.widthY);
                $("#update-input-longX").val(paramRealEstate.longX);
                $("#update-input-streetHouse").val(paramRealEstate.streetHouse);
                $("#update-input-fsbo").val(paramRealEstate.fsbo);
                $("#update-input-viewNum").val(paramRealEstate.viewNum);
                $("#update-input-updateBy").val(paramRealEstate.updateBy);

                $("#update-input-shape").val(paramRealEstate.shape);
                $("#update-input-distance2facade").val(paramRealEstate.distance2facade);
                $("#update-input-adjacent_facade_num").val(paramRealEstate.adjacent_facade_num);
                $("#update-input-adjacentRoad").val(paramRealEstate.adjacentRoad);
                $("#update-input-alley_min_width").val(paramRealEstate.alley_min_width);
                $("#update-input-adjacent_alley_min_width").val(paramRealEstate.adjacent_alley_min_width);
                $("#update-input-factor").val(paramRealEstate.factor);
                $("#update-input-structure").val(paramRealEstate.structure);
                $("#update-input-dtsxd").val(paramRealEstate.dtsxd);
                $("#update-input-clcl").val(paramRealEstate.clcl);
                $("#update-input-ctxd_price").val(paramRealEstate.ctxd_price);

                $("#update-input-ctxd_value").val(paramRealEstate.ctxd_value);
                $("#update-input-photo").val(paramRealEstate.photo);
                $("#update-input-lat").val(paramRealEstate.lat);
                $("#update-input-lng").val(paramRealEstate.lng);
            }



            function redirectToLogin() {
                // Trước khi logout cần xóa token đã lưu trong cookie
                setCookie("token", "", 1);
                window.location.href = "index.html";
            }

            //Hàm get Cookie
            function getCookie(cname) {
                var name = cname + "=";
                var decodedCookie = decodeURIComponent(document.cookie);
                var ca = decodedCookie.split(';');
                for (var i = 0; i < ca.length; i++) {
                    var c = ca[i];
                    while (c.charAt(0) == ' ') {
                        c = c.substring(1);
                    }
                    if (c.indexOf(name) == 0) {
                        return c.substring(name.length, c.length);
                    }
                }
                return "";
            }

            //Hàm setCookie đã giới thiệu ở bài trước
            function setCookie(cname, cvalue, exdays) {
                var d = new Date();
                d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
                var expires = "expires=" + d.toUTCString();
                document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
            }

            // Hàm alert lỗi
            function alertError(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'error',
                        title: paramTitle,
                    })
                });
            }

        });
    </script>
</body>